#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fcntl.h>
#include <unistd.h>
#include "stdint.h"
#include <time.h>
#include <errno.h> 

short sound[16000];
#define arrSize 16000

// millisecond sleep
int msleep(long msec)
{
    struct timespec ts;
    int res;

    if (msec < 0)
    {
        errno = EINVAL;
        return -1;
    }

    ts.tv_sec = msec / 1000;
    ts.tv_nsec = (msec % 1000) * 1000000;

    do
    {
        res = nanosleep(&ts, &ts);
    } while (res && errno == EINTR);

    return res;
}

int main() {
    // copy sampled values to array
    int size = 200;
    uint16_t buf[200];
    int fd = open("/dev/iio:device0", O_RDONLY | O_NONBLOCK);
    if (fd == -1)
    {
        printf("error");
        exit(1);
    }


    int count = 0;
    while (1)
    {
        read(fd, buf, size * sizeof(uint16_t));
        for (int i = 0; i < size; i++)
        {
            if (count > arrSize)
            {
                count = 0;
            }

            
            sound[count] = buf[i];
        
            printf("%d\n", sound[count]);

            count++;
        }
        msleep(25);
    }
}